require 'settings'

class Controller
  attr_accessor :is_finished, :next_controller
  
  def initialize
    @is_finished = false
    @keys = []
  end
  
  def update(dtime)
  end
  
  def handle_event(event)
    case event
      when Rubygame::Events::KeyPressed
        @keys += [event.key]
      when Rubygame::Events::KeyReleased
        @keys -= [event.key]
    end
  end
  
  def draw(srf)
    srf.fill [0, 0, 0]
  end
  
  def finish!(next_controller = nil, fadeover_effect = nil)
    @is_finished = true
    @next_controller = next_controller
    Game.fadeover_effect = fadeover_effect
  end
end
