require 'settings'
require 'controllers/controller'
require 'player'

class MenuController < Controller
  def initialize
    super
    
    @selected_item = 0
    @bomb_sprite = Sprite.new("bomb.png", {
      :default => { :row => 0, :frames => 2, :framerate => 0.008 }
    })
    @bomb_sprite.current_animation = :default
    
    @menu_items = []
    
    Rubygame::Music['menu.wav'].volume = Settings.audio.music_volume_menu
  end
  
  def update(dtime)
    @bomb_sprite.update(dtime)
  end
  
  def handle_event(event)
    super event
    
    if @keys.include?(:up)
      @selected_item -= 1 unless @selected_item == 0
      @keys.delete(:up)
    end
    if @keys.include?(:down)
      @selected_item += 1 unless @selected_item == @menu_items.size - 1
      @keys.delete(:down)
    end
    
    if @keys.include?(:return)
      if @keys.include?(:left_ctrl)
        @menu_items[@selected_item][:on_select_alternative].call unless @menu_items[@selected_item][:on_select_alternative].nil?
      else
        @menu_items[@selected_item][:on_select].call unless @menu_items[@selected_item][:on_select].nil?
      end
    end
  end
  
  def draw(srf)
    @menu_items.each_with_index do |item, i|
      Game.font.render(item[:title], false, [255, 255, 255]).blit srf, [100, 30 + 40*i]
    end
    @bomb_sprite.draw srf, V(50, 25 + 40*@selected_item)
  end
end
