require 'fadeover_effects/fadeover_effect'
require 'fadeover_effects/crossfade_effect'

class FlashFadeEffect < FadeoverEffect
  def initialize(flash_duration = 150, fade_duration = 1000, flash_color = [255, 255, 255])
    super()
    @flash_duration = flash_duration
    @fade_duration = fade_duration
    @flash = Rubygame::Surface.new [Game.screen.w, Game.screen.h]
    @flash.fill flash_color
    @finish_next_frame = false
  end
  
  def update(dtime)
    if @finish_next_frame
      finish! CrossfadeEffect.new(@fade_duration)
    else
      @time += dtime
      @flash.alpha = [255 * @time/@flash_duration, 255].min
      @finish_next_frame = true if @time >= @flash_duration # makes sure that the screen is completely white
    end
  end
  
  def draw(srf)
    super srf
    @flash.blit srf, [0, 0]
  end
end
