require 'items/item'

class Explosion < Item
  attr_accessor :player, :countdown, :explosion_id
  
  @@last_explosion_id = 0
  
  def initialize(field, player = nil, explosion_id = nil, draw = true)
    @player = player
    @countdown = Settings.gameplay.explosion_time
    @draw = draw
    if explosion_id.nil?
      @@last_explosion_id += 1
      @explosion_id = @@last_explosion_id
    else
      @explosion_id = explosion_id
    end
    
    super field, !@draw ? nil : Sprite.new("explosion.png", :default => {
      :row => 0,
      :frames => 6,
      :framerate => 0.01
    })
    @sprite.current_animation = :default unless @sprite.nil?
    
    @field.blown(self)
  end
  
  def update(dtime)
    super dtime
    
    @countdown -= dtime
    if @countdown <= 0
      @field.items -= [self]
    end
  end
  
  def draw(srf, offset)
    super srf, offset if @draw
  end
  
  def walkable?
    true
  end
  def blowable?
    true
  end
  def blocks_explosion?
    false
  end
end
